<?php
/**
 * Functions which enhance the theme by hooking into WordPress
 *
 * @package electrical_services
 */

function electrical_services_body_classes( $electrical_services_classes ) {
	// Adds a class of hfeed to non-singular pages.
	if ( ! is_singular() ) {
		$electrical_services_classes[] = 'hfeed';
	}

	// Adds a class of no-sidebar when there is no sidebar present.
	if ( ! is_active_sidebar( 'sidebar-1' ) ) {
		$electrical_services_classes[] = 'no-sidebar';
	}

	$electrical_services_classes[] = electrical_services_sidebar_layout();

	return $electrical_services_classes;
}
add_filter( 'body_class', 'electrical_services_body_classes' );

/**
 * Add a pingback url auto-discovery header for single posts, pages, or attachments.
 */
function electrical_services_pingback_header() {
	if ( is_singular() && pings_open() ) {
		printf( '<link rel="pingback" href="%s">', esc_url( get_bloginfo( 'pingback_url' ) ) );
	}
}
add_action( 'wp_head', 'electrical_services_pingback_header' );


/**
 * Get all posts for customizer Post content type.
 */
function electrical_services_get_post_choices() {
	$electrical_services_choices = array( '' => esc_html__( '--Select--', 'electrical-services' ) );
	$electrical_services_args    = array( 'numberposts' => -1 );
	$electrical_services_posts   = get_posts( $electrical_services_args );

	foreach ( $electrical_services_posts as $electrical_services_post ) {
		$electrical_services_id             = $electrical_services_post->ID;
		$electrical_services_title          = $electrical_services_post->post_title;
		$electrical_services_choices[ $electrical_services_id ] = $electrical_services_title;
	}

	return $electrical_services_choices;
}

/**
 * Get all pages for customizer Page content type.
 */
function electrical_services_get_page_choices() {
	$electrical_services_choices = array( '' => esc_html__( '--Select--', 'electrical-services' ) );
	$electrical_services_pages   = get_pages();

	foreach ( $electrical_services_pages as $electrical_services_page ) {
		$electrical_services_choices[ $electrical_services_page->ID ] = $electrical_services_page->post_title;
	}

	return $electrical_services_choices;
}

/**
 * Get all categories for customizer Category content type.
 */
function electrical_services_get_post_cat_choices() {
	$electrical_services_choices = array( '' => esc_html__( '--Select--', 'electrical-services' ) );
	$electrical_services_cats    = get_categories();

	foreach ( $electrical_services_cats as $electrical_services_cat ) {
		$electrical_services_choices[ $electrical_services_cat->term_id ] = $electrical_services_cat->name;
	}

	return $electrical_services_choices;
}

/**
 * Get all donation forms for customizer form content type.
 */
function electrical_services_get_post_donation_form_choices() {
	$electrical_services_choices = array( '' => esc_html__( '--Select--', 'electrical-services' ) );
	$electrical_services_posts   = get_posts(
		array(
			'post_type'   => 'give_forms',
			'numberposts' => -1,
		)
	);
	foreach ( $electrical_services_posts as $electrical_services_post ) {
		$electrical_services_choices[ $electrical_services_post->ID ] = $electrical_services_post->post_title;
	}
	return $electrical_services_choices;
}

if ( ! function_exists( 'electrical_services_excerpt_length' ) ) :
	/**
	 * Excerpt length.
	 */
	function electrical_services_excerpt_length( $electrical_services_length ) {
		if ( is_admin() ) {
			return $electrical_services_length;
		}

		return get_theme_mod( 'electrical_services_excerpt_length', 20 );
	}
endif;
add_filter( 'excerpt_length', 'electrical_services_excerpt_length', 999 );

if ( ! function_exists( 'electrical_services_excerpt_more' ) ) :
	/**
	 * Excerpt more.
	 */
	function electrical_services_excerpt_more( $electrical_services_more ) {
		if ( is_admin() ) {
			return $electrical_services_more;
		}

		return '&hellip;';
	}
endif;
add_filter( 'excerpt_more', 'electrical_services_excerpt_more' );

if ( ! function_exists( 'electrical_services_sidebar_layout' ) ) {
	/**
	 * Get sidebar layout.
	 */
	function electrical_services_sidebar_layout() {
		$electrical_services_sidebar_position      = get_theme_mod( 'electrical_services_sidebar_position', 'right-sidebar' );
		$electrical_services_sidebar_position_post = get_theme_mod( 'electrical_services_post_sidebar_position', 'right-sidebar' );
		$electrical_services_sidebar_position_page = get_theme_mod( 'electrical_services_page_sidebar_position', 'right-sidebar' );

		if ( is_home() ) {
			$electrical_services_sidebar_position = $electrical_services_sidebar_position_post;
		} elseif ( is_page() ) {
			$electrical_services_sidebar_position = $electrical_services_sidebar_position_page;
		}

		return $electrical_services_sidebar_position;
	}
}

if ( ! function_exists( 'electrical_services_is_sidebar_enabled' ) ) {
	/**
	 * Check if sidebar is enabled.
	 */
	function electrical_services_is_sidebar_enabled() {
		$electrical_services_sidebar_position      = get_theme_mod( 'electrical_services_sidebar_position', 'right-sidebar' );
		$electrical_services_sidebar_position_post = get_theme_mod( 'electrical_services_post_sidebar_position', 'right-sidebar' );
		$electrical_services_sidebar_position_page = get_theme_mod( 'electrical_services_page_sidebar_position', 'right-sidebar' );

		$electrical_services_sidebar_enabled = true;
		if ( is_single() || is_archive() || is_search() ) {
			if ( 'no-sidebar' === $electrical_services_sidebar_position ) {
				$electrical_services_sidebar_enabled = false;
			}
		} elseif ( is_home() ) {
			if ( 'no-sidebar' === $electrical_services_sidebar_position || 'no-sidebar' === $electrical_services_sidebar_position_post ) {
				$electrical_services_sidebar_enabled = false;
			}
		} elseif ( is_page() ) {
			if ( 'no-sidebar' === $electrical_services_sidebar_position || 'no-sidebar' === $electrical_services_sidebar_position_page ) {
				$electrical_services_sidebar_enabled = false;
			}
		}
		return $electrical_services_sidebar_enabled;
	}
}

if ( ! function_exists( 'electrical_services_get_homepage_sections ' ) ) {
	/**
	 * Returns homepage sections.
	 */
	function electrical_services_get_homepage_sections() {
		$electrical_services_sections = array(
			'banner'  => esc_html__( 'Banner Section', 'electrical-services' ),
			'services' => esc_html__( 'Services Section', 'electrical-services' ),
		);
		return $electrical_services_sections;
	}
}

/**
 * Renders customizer section link
 */
function electrical_services_section_link( $electrical_services_section_id ) {
	$electrical_services_section_name      = str_replace( 'electrical_services_', ' ', $electrical_services_section_id );
	$electrical_services_section_name      = str_replace( '_', ' ', $electrical_services_section_name );
	$electrical_services_starting_notation = '#';
	?>
	<span class="section-link">
		<span class="section-link-title"><?php echo esc_html( $electrical_services_section_name ); ?></span>
	</span>
	<style type="text/css">
		<?php echo $electrical_services_starting_notation . $electrical_services_section_id; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>:hover .section-link {
			visibility: visible;
		}
	</style>
	<?php
}

/**
 * Adds customizer section link css
 */
function electrical_services_section_link_css() {
	if ( is_customize_preview() ) {
		?>
		<style type="text/css">
			.section-link {
				visibility: hidden;
				background-color: black;
				position: relative;
				top: 80px;
				z-index: 99;
				left: 40px;
				color: #fff;
				text-align: center;
				font-size: 20px;
				border-radius: 10px;
				padding: 20px 10px;
				text-transform: capitalize;
			}

			.section-link-title {
				padding: 0 10px;
			}

			.banner-section {
				position: relative;
			}

			.banner-section .section-link {
				position: absolute;
				top: 100px;
			}
		</style>
		<?php
	}
}
add_action( 'wp_head', 'electrical_services_section_link_css' );

/**
 * Breadcrumb.
 */
function electrical_services_breadcrumb( $electrical_services_args = array() ) {
	if ( ! get_theme_mod( 'electrical_services_enable_breadcrumb', true ) ) {
		return;
	}

	$electrical_services_args = array(
		'show_on_front' => false,
		'show_title'    => true,
		'show_browse'   => false,
	);
	electrical_services_breadcrumb_trail( $electrical_services_args );
}
add_action( 'electrical_services_breadcrumb', 'electrical_services_breadcrumb', 10 );

/**
 * Add separator for breadcrumb trail.
 */
function electrical_services_breadcrumb_trail_print_styles() {
	$electrical_services_breadcrumb_separator = get_theme_mod( 'electrical_services_breadcrumb_separator', '/' );

	$electrical_services_style = '
		.trail-items li::after {
			content: "' . $electrical_services_breadcrumb_separator . '";
		}'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped

	$electrical_services_style = apply_filters( 'electrical_services_breadcrumb_trail_inline_style', trim( str_replace( array( "\r", "\n", "\t", '  ' ), '', $electrical_services_style ) ) );

	if ( $electrical_services_style ) {
		echo "\n" . '<style type="text/css" id="breadcrumb-trail-css">' . $electrical_services_style . '</style>' . "\n"; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
	}
}
add_action( 'wp_head', 'electrical_services_breadcrumb_trail_print_styles' );

/**
 * Pagination for archive.
 */
function electrical_services_render_posts_pagination() {
	$electrical_services_is_pagination_enabled = get_theme_mod( 'electrical_services_enable_pagination', true );
	if ( $electrical_services_is_pagination_enabled ) {
		$electrical_services_pagination_type = get_theme_mod( 'electrical_services_pagination_type', 'default' );
		if ( 'default' === $electrical_services_pagination_type ) :
			the_posts_navigation();
		else :
			the_posts_pagination();
		endif;
	}
}
add_action( 'electrical_services_posts_pagination', 'electrical_services_render_posts_pagination', 10 );

/**
 * Pagination for single post.
 */
function electrical_services_render_post_navigation() {
	the_post_navigation(
		array(
			'prev_text' => '<span>&#10229;</span> <span class="nav-title">%title</span>',
			'next_text' => '<span class="nav-title">%title</span> <span>&#10230;</span>',
		)
	);
}
add_action( 'electrical_services_post_navigation', 'electrical_services_render_post_navigation' );

/**
 * Adds footer copyright text.
 */
function electrical_services_output_footer_copyright_content() {
    $electrical_services_theme_data = wp_get_theme();
    $electrical_services_copyright_text = get_theme_mod('electrical_services_footer_copyright_text');

	if (!empty($electrical_services_copyright_text)) {
        $electrical_services_text = $electrical_services_copyright_text;
    } else {

		$electrical_services_default_text = esc_html($electrical_services_theme_data->get('Name')) . '&nbsp;' . esc_html__('by', 'electrical-services') . '&nbsp;<a target="_blank" href="' . esc_url($electrical_services_theme_data->get('AuthorURI')) . '">' . esc_html(ucwords($electrical_services_theme_data->get('Author'))) . '</a>';
		/* translators: %s: WordPress.org URL */
        $electrical_services_default_text .= sprintf(esc_html__(' | Powered by %s', 'electrical-services'), '<a href="' . esc_url(__('https://wordpress.org/', 'electrical-services')) . '" target="_blank">WordPress</a>. ');

        $electrical_services_text = $electrical_services_default_text;

    }
    ?>
    <span><?php echo wp_kses_post($electrical_services_text); ?></span>
    <?php
}
add_action('electrical_services_footer_copyright', 'electrical_services_output_footer_copyright_content');

/* Footer Social Icons */ 
function electrical_services_footer_social_links() {

    if ( get_theme_mod('electrical_services_enable_footer_icon_section', true) ) {

            ?>
            <div class="socialicons">
				<div class="asterthemes-wrapper">
					<?php if ( get_theme_mod('electrical_services_footer_facebook_link', 'https://www.facebook.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('electrical_services_footer_facebook_link', 'https://www.facebook.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('electrical_services_facebook_icon', 'fab fa-facebook-f')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Facebook', 'electrical-services'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('electrical_services_footer_twitter_link', 'https://x.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('electrical_services_footer_twitter_link', 'https://x.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('electrical_services_twitter_icon', 'fab fa-twitter')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Twitter', 'electrical-services'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('electrical_services_footer_instagram_link', 'https://www.instagram.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('electrical_services_footer_instagram_link', 'https://www.instagram.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('electrical_services_instagram_icon', 'fab fa-instagram')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Instagram', 'electrical-services'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('electrical_services_footer_linkedin_link', 'https://in.linkedin.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('electrical_services_footer_linkedin_link', 'https://in.linkedin.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('electrical_services_linkedin_icon', 'fab fa-linkedin')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Linkedin', 'electrical-services'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('electrical_services_footer_youtube_link', 'https://www.youtube.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('electrical_services_footer_youtube_link', 'https://www.youtube.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('electrical_services_youtube_icon', 'fab fa-youtube')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Youtube', 'electrical-services'); ?></span>
						</a>
					<?php } ?>
				</div>
            </div>
            <?php
    }
}
add_action('wp_footer', 'electrical_services_footer_social_links');

if ( ! function_exists( 'electrical_services_footer_widget' ) ) :
	function electrical_services_footer_widget() {
		$electrical_services_footer_widget_column = get_theme_mod('electrical_services_footer_widget_column','4');

		$electrical_services_column_class = '';
		if ($electrical_services_footer_widget_column == '1') {
			$electrical_services_column_class = 'one-column';
		} elseif ($electrical_services_footer_widget_column == '2') {
			$electrical_services_column_class = 'two-columns';
		} elseif ($electrical_services_footer_widget_column == '3') {
			$electrical_services_column_class = 'three-columns';
		} else {
			$electrical_services_column_class = 'four-columns';
		}
	
		if($electrical_services_footer_widget_column !== ''): 
		?>
		<div class="dt_footer-widgets <?php echo esc_attr($electrical_services_column_class); ?>">
			<div class="footer-widgets-column">
				<?php
				$footer_widgets_active = false;

				// Loop to check if any footer widget is active
				for ($electrical_services_i = 1; $electrical_services_i <= $electrical_services_footer_widget_column; $electrical_services_i++) {
					if (is_active_sidebar('footer-widget-' . $electrical_services_i)) {
						$footer_widgets_active = true;
						break;
					}
				}

				if ($footer_widgets_active) {
					// Display active footer widgets
					for ($electrical_services_i = 1; $electrical_services_i <= $electrical_services_footer_widget_column; $electrical_services_i++) {
						if (is_active_sidebar('footer-widget-' . $electrical_services_i)) : ?>
							<div class="footer-one-column">
								<?php dynamic_sidebar('footer-widget-' . $electrical_services_i); ?>
							</div>
						<?php endif;
					}
				} else {
				?>
				<div class="footer-one-column default-widgets">
					<aside id="search-2" class="widget widget_search default_footer_search">
						<div class="widget-header">
							<h4 class="widget-title"><?php esc_html_e('Search Here', 'electrical-services'); ?></h4>
						</div>
						<?php get_search_form(); ?>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="recent-posts-2" class="widget widget_recent_entries">
						<h2 class="widget-title"><?php esc_html_e('Recent Posts', 'electrical-services'); ?></h2>
						<ul>
							<?php
							$recent_posts = wp_get_recent_posts(array(
								'numberposts' => 5,
								'post_status' => 'publish',
							));
							foreach ($recent_posts as $post) {
								echo '<li><a href="' . esc_url(get_permalink($post['ID'])) . '">' . esc_html($post['post_title']) . '</a></li>';
							}
							wp_reset_query();
							?>
						</ul>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="recent-comments-2" class="widget widget_recent_comments">
						<h2 class="widget-title"><?php esc_html_e('Recent Comments', 'electrical-services'); ?></h2>
						<ul>
							<?php
							$recent_comments = get_comments(array(
								'number' => 5,
								'status' => 'approve',
							));
							foreach ($recent_comments as $comment) {
								echo '<li><a href="' . esc_url(get_comment_link($comment)) . '">' .
									/* translators: %s: details. */
									sprintf(esc_html__('Comment on %s', 'electrical-services'), get_the_title($comment->comment_post_ID)) .
									'</a></li>';
							}
							?>
						</ul>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="categories" class="widget py-3" role="complementary" aria-label="<?php esc_attr_e('footer1', 'electrical-services'); ?>">
                        <h3 class="widget-title"><?php esc_html_e('Categories', 'electrical-services'); ?></h3>
                        <ul>
                            <?php wp_list_categories(array(
                                'title_li' => '',
                                'number'   => 5
                            )); ?>
                        </ul>
                    </aside>
				</div>
			</div>
			<?php } ?>
		</div>
		<?php
		endif;
	}
	endif;
add_action( 'electrical_services_footer_widget', 'electrical_services_footer_widget' );


function electrical_services_footer_text_transform_css() {
    $electrical_services_footer_text_transform = get_theme_mod('footer_text_transform', 'none');
    ?>
    <style type="text/css">
        .site-footer h4,footer#colophon h2.wp-block-heading,footer#colophon .widgettitle,footer#colophon .widget-title {
            text-transform: <?php echo esc_html($electrical_services_footer_text_transform); ?>;
        }
    </style>
    <?php
}
add_action('wp_head', 'electrical_services_footer_text_transform_css');